import React from "react";
type TagName = keyof JSX.IntrinsicElements;
type Component<P> = React.FC<P> | React.ComponentClass<P> | TagName;
type Props<C extends Component<any>> = C extends TagName ? JSX.IntrinsicElements[C] : C extends React.FC<infer P> ? P : C extends React.ComponentClass<infer P> ? P : never;
type DefaultProps = {
    className?: string;
    children?: any;
};
interface DyeComponent<C extends Component<DefaultProps>, Variants extends Record<string, string>> extends React.FC<Props<C> & {
    variant?: keyof Variants;
}> {
    as<D extends Component<DefaultProps>>(x: D): DyeComponent<D, Variants>;
}
export default function dye<C extends Component<{
    className?: string;
}>, Variants extends Record<string, string> = {}>(defaultClassName: string, DefaultComponent?: C, variants?: Variants): DyeComponent<C, Variants>;
export default dye;

//# sourceMappingURL=index.d.ts.map
